unit BanUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TfrmBan = class(TForm)
    gbConnPolice: TGroupBox;
    tcBan: TTabControl;
    btnDel: TSpeedButton;
    btnAdd: TSpeedButton;
    btnEdit: TSpeedButton;
    btnClear: TSpeedButton;
    lbItemsList: TListBox;
    gbConnParams: TGroupBox;
    cbRejectConn: TCheckBox;
    btnExit: TSpeedButton;
    cbAntiFlood: TCheckBox;
    Bevel1: TBevel;
    procedure btnClick(Sender: TObject);
    procedure tcBanChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure lbItemsListKeyPress(Sender: TObject; var Key: Char);
    procedure lbItemsListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbItemsListDblClick(Sender: TObject);
  private
    { Private declarations }
    FListBannedIP:   TStringList;
    FListAllowedIP:  TStringList;
  public
    { Public declarations }
    procedure AddIPToBanList(const IP: String);
    function IPInBanList(const IP: String): Integer;
    function IPInAllowedList(const IP: String): Integer;
  end;

var
  frmBan: TfrmBan;

implementation

{$R *.dfm}
//---------------------------------------------------------------------------
procedure TfrmBan.AddIPToBanList;
Begin
  try
    if (IP = '') Then raise EAbort.Create('IP is void');
    if (FListBannedIP.IndexOf(IP) <> -1) Then raise EAbort.Create('IP is duplicated');
    FListBannedIP.Add(IP);
    if (tcBan.TabIndex = 0) Then
      Begin
        lbItemsList.Items.Add(IP);
        lbItemsList.ItemIndex := lbItemsList.Count - 1;
      End;
  except
  end;
End;
//---------------------------------------------------------------------------
function TfrmBan.IPInBanList;
Begin
  Result := FListBannedIP.IndexOf(IP);
End;
//---------------------------------------------------------------------------
function TfrmBan.IPInAllowedList;
Begin
  Result := FListAllowedIP.IndexOf(IP);
End;
//---------------------------------------------------------------------------
procedure TfrmBan.btnClick(Sender: TObject);
Var PCurList: ^TStringList;
    S: String;
    CurItemIndex: Integer;

begin
//
  case tcBan.TabIndex of
    0: PCurList := @FListBannedIP;
    1: PCurList := @FListAllowedIP;
    else PCurList := nil;
  end;
  CurItemIndex := lbItemsList.ItemIndex;
  if (Sender = btnAdd) Then
    Begin
      S := InputBox(' ', '  :', '');
      try
        if (S = '') Then raise EAbort.Create('String is void');
        PCurList.Add(S);
        lbItemsList.Items.Add(S);
        lbItemsList.ItemIndex := lbItemsList.Count - 1;
      except
      end;
    End
  else if (Sender = btnClear) Then
    Begin
      PCurList.Clear;
      lbItemsList.Clear;
    End
  else if (Sender = btnDel) Then
    Begin
      if (CurItemIndex > -1) Then
        Begin
          PCurList.Delete(CurItemIndex);
          lbItemsList.DeleteSelected;
          // if
          CurItemIndex := CurItemIndex - Byte(CurItemIndex >= lbItemsList.Count);
          lbItemsList.ItemIndex := CurItemIndex;
        End;
    End
  else if (Sender = btnEdit) Then
    Begin
      if (CurItemIndex <= -1) Then exit;
      S := lbItemsList.Items.Strings[CurItemIndex];
      S := InputBox(' ', '  :', S);
      try
        PCurList.Delete(CurItemIndex);
        PCurList.Insert(CurItemIndex, S);
        lbItemsList.DeleteSelected;
        lbItemsList.Items.Insert(CurItemIndex, S);
        lbItemsList.ItemIndex := CurItemIndex;
      except
      end;
    End;
end;
//---------------------------------------------------------------------------
procedure TfrmBan.tcBanChange(Sender: TObject);
begin
  lbItemsList.Clear;
  case tcBan.TabIndex of
    0: Begin
        lbItemsList.Color := clMedGray;    
        lbItemsList.Items.Assign(FListBannedIP);
    End;
    1: Begin
        lbItemsList.Color := clSkyBlue;
        lbItemsList.Items.Assign(FListAllowedIP);
    End;
    else
  end;
end;
//---------------------------------------------------------------------------
procedure TfrmBan.FormCreate(Sender: TObject);
begin
  FListBannedIP     := TStringList.Create;
  FListAllowedIP    := TStringList.Create;
  FListBannedIP.Duplicates  := dupError;
  FListAllowedIP.Duplicates := dupError;
end;
//---------------------------------------------------------------------------
procedure TfrmBan.FormDestroy(Sender: TObject);
begin
  FListBannedIP.Free;
  FListAllowedIP.Free;
  lbItemsList.Clear;
end;
//---------------------------------------------------------------------------
procedure TfrmBan.FormShow(Sender: TObject);
//      
begin
  tcBanChange(nil);
end;
//---------------------------------------------------------------------------
procedure TfrmBan.btnExitClick(Sender: TObject);
begin
  Close();
end;
//---------------------------------------------------------------------------
procedure TfrmBan.lbItemsListKeyPress(Sender: TObject; var Key: Char);
begin

end;
//---------------------------------------------------------------------------
procedure TfrmBan.lbItemsListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_RETURN:
      Begin
        btnEdit.Click;
        Key := 0;
      End;
    VK_DELETE:
      Begin
        if (ssShift in Shift) Then btnClear.Click
          else btnDel.Click;
        Key := 0;
      End;
    VK_INSERT:
      Begin
        btnAdd.Click;
        Key := 0;
      End;
    else
  end;
end;
//---------------------------------------------------------------------------
procedure TfrmBan.lbItemsListDblClick(Sender: TObject);
begin
  btnEdit.Click;
end;
//---------------------------------------------------------------------------
procedure TfrmBan.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) Then btnExit.Click;
end;
//---------------------------------------------------------------------------

end.
