unit MainUnit;
//{$DEFINE DEBUG}
//    
{$DEFINE NO_PRIVATE_LOGGING}


{$I ../inc/comparam.inc}

interface

uses Windows, Dialogs, Menus, StdCtrls, ExtCtrls, Controls, Classes, Graphics,
      ScktComp, Forms, SysUtils, BanUnit, Buttons;
{$IFNDEF NO_PRIVATE_LOGGING}
  uses Cipher, DECUtil;
{$ENDIF}

const
   {$I ../inc/consts.inc}
   stWorking   = '';
   stStop      = '';
   stConn      = '';
   stDisConn   = '';
   stError     = ' ';
   stBan       = '';

   //   
   maxClnNum            = 255;
   // ,        ()
   CloseSleepInterval   = 1500;

   //      
   AF_CheckMsgCount     = 10;
   //   ,   AF_CheckMsgCount 
   AF_Time              = 0.00005;

   srvVersion  =  ChatVersion;   //  
   srvName     =  'Lambda';      //  
   //  
   srvAddInfo   =  'A.N. test server';
{$IFNDEF NO_PRIVATE_LOGGING}
   //  
   ProtoDsk     = 'H';
   ProtoDir     = 'err_logs';
{$ENDIF}

type
  {$I ../inc/structs.inc}
  PServerWinSocket = ^TServerWinSocket;
  PCustomWinSocket = ^TCustomWinSocket;
  PClientInfo = ^TClientInfo;

  TFloodCounter = record
      //    
      MsgCount  : Byte;
      //   
      StartTime : TDateTime;
  end;

  TVirtualChannel = record
      RecieverSock   : TCustomWinSocket;  //    
      RecieverNick   : String;            //  
      ChannelOpenFl  : Boolean;           //   
  end;

  TClientInfo = record
      User      : TUser;
      FloodCnt  : TFloodCounter;
      Channel   : TVirtualChannel;
  end;

  TfrmMain = class(TForm)
    pnMain: TPanel;
    pnLog: TPanel;
    pnControl: TPanel;
    pnStatus: TPanel;
    lstLog: TListBox;
    btnLogClear: TSpeedButton;
    chbLogState: TCheckBox;
    edPort: TEdit;
    Label1: TLabel;
    Bevel1: TBevel;
    btnBan: TSpeedButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    statusState: TEdit;
    statusClnNum: TEdit;
    statusIPCln: TEdit;
    Label6: TLabel;
    cbBanIP: TComboBox;
    popLog: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    dlgSave: TOpenDialog;
    btnLogSave: TSpeedButton;
    N3: TMenuItem;
    Label7: TLabel;
    statusIPServer: TEdit;
    btnBanList: TSpeedButton;
    btnStart: TSpeedButton;
    btnExit: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnCtrlClick(Sender: TObject);
    procedure btnLogClick(Sender: TObject);
    procedure cbBanIPSelect(Sender: TObject);
    procedure Label6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
     FsrvSock: TServerSocket;
     FSeedArray: Array[0..9] of Integer;
{$IFNDEF NO_PRIVATE_LOGGING}
     FProtoStream: TStringList;
     FProtoSaving: Boolean;
     FKey: String;
     FCipher: TCipher_TEAN;
{$ENDIF}     
     procedure SrvSockAccept(Sender: TObject; Socket: TCustomWinSocket);
     procedure SrvSockRead(Sender: TObject; Socket: TCustomWinSocket);
     procedure SrvSockListen(Sender: TObject; Socket: TCustomWinSocket);
     procedure SrvSockClnConn(Sender: TObject; Socket: TCustomWinSocket);
     procedure SrvSockClnDisConn(Sender: TObject; Socket: TCustomWinSocket);
     procedure SrvSockError(Sender: TObject; Socket: TCustomWinSocket;
       ErrorEvent: TErrorEvent; var ErrorCode: Integer);
     procedure SendToAll(S: String; ExclSocket: PCustomWinSocket = nil);
     procedure AddToLog(S: String);
     function ParseCmd(Var Cmd, CmdParam: String) : String;
     procedure RunCmd(CmdString: String; Socket: PCustomWinSocket = nil);
     function CheckNickCorrectness(Nick: String) : boolean;
     procedure CloseSrvSocket;
     function GetSockByNick(Nick: String) : TCustomWinSocket;
     procedure Ban();
     function AF_FloodCheck(Socket: TCustomWinSocket): Boolean;
{$IFNDEF NO_PRIVATE_LOGGING}
     procedure Proto(Msg: String);
     procedure SaveProto;
{$ENDIF}     
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  CurUser: PClientInfo;

implementation

{$R *.dfm}
//---------------------------------------------------------------------------
{$IFNDEF NO_PRIVATE_LOGGING}
procedure TfrmMain.Proto(Msg: String);
//   
Begin
   FProtoStream.Add(Msg);
End;
{$ENDIF}
//---------------------------------------------------------------------------
function TfrmMain.GetSockByNick(Nick: String) : TCustomWinSocket;
//      
Var i : Integer;
Begin
   for i := 0 To FSrvSock.Socket.ActiveConnections - 1
      Do
         if (PClientInfo(FSrvSock.Socket.Connections[i].Data)^.User.Nick = Nick) Then
            Begin
               Result := FSrvSock.Socket.Connections[i];
               exit;
            End;
   Result := nil;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.CloseSrvSocket;
//   
Var i: Integer;
Begin
   if (not FSrvSock.Active) Then exit;
   SendToAll(ctrlSym + 'BYE');
   btnStart.Enabled := false;
   //      
   Sleep(CloseSleepInterval);
   //  
   for i := 0 To FSrvSock.Socket.ActiveConnections - 1
      Do
         FSrvSock.Socket.Connections[i].Close;
   btnStart.Enabled := true;
   FSrvSock.Close;
   if (Not FSrvSock.Active) Then
      Begin
         edPort.Enabled := true;
         btnStart.Caption := '';
         cbBanIP.Clear;
         statusIPCln.Clear;
         statusClnNum.Text := '0';
         statusIPServer.Clear;
         statusState.Text := stStop;
         AddToLog(' ');
      End
   Else AddToLog('   ');
End;
//---------------------------------------------------------------------------
function TfrmMain.CheckNickCorrectness(Nick: String) : boolean;
//    
//         
Var i: Integer;

Begin
   Nick := AnsiUpperCase(Nick);
   if (Nick = AnsiUpperCase(srvNick)) Then
      Begin
         Result := false;
         exit;
      End;

   Nick := Trim(Nick);

   if (Nick = '') Then
      Begin
         Result := false;
         exit;
      End;

   for i := 1 To Length(Nick)
   //    
      Do
         Begin
            if ((Nick[i] = ctrlSym) or (Nick[i] = delimSym) or
               (Nick[i] < ' ')) Then
               Begin
                  Result := false;
                  exit;
               End;
         End;

   for i := 0 To FsrvSock.Socket.ActiveConnections - 1
   //    
      Do
         if (AnsiUpperCase(PClientInfo(FsrvSock.Socket.Connections[I].Data).User.Nick) = Nick) Then
            Begin
               Result := false;
               exit;
            End;

   Result := true;
End;
//---------------------------------------------------------------------------
function TfrmMain.ParseCmd;
//    
//  ''   
// CmdParam -  
// Cmd -  .      .
// [1] -   -   :.
// [2] -   ,      
//   ,     Link.
//       .
Var I: Integer;
    Param: String;
    Link: ^String;         //    

Begin
   //   
   Link := @Param;
   CmdParam := '';
   //   - __ . .
   For I:=2 To Length(Cmd)
      Do
         Begin
            if (Cmd[i] = ctrlSym) Then break; // [1]
            if (Cmd[i] = delimSym) Then
               Begin
                  // [2]
                  Link := @CmdParam;
                  continue;
               End;
            Link^ := Link^ + Cmd[I];
         End;
   //   
   Cmd := Copy(Cmd, I, Length(Cmd) - I + 1);
   Result := Param;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.RunCmd;
//  
Var Value, Key:   String;
    I:            Integer;
Begin
   Repeat
      if (CmdString[1] <> ctrlSym) Then break;
      Key := ParseCmd(CmdString, Value);
      if (Key = 'NICK') Then
      // 
         Begin
            if (CheckNickCorrectness(Value)) Then PClientInfo(Socket.Data).User.Nick := Value;
            continue;
         End;
      if (Key = 'NICK_COLOR') Then
      //  
         Begin
            PClientInfo(Socket.Data).User.NickColor := StrToIntDef(Value, 0);
            continue;
         End;
      if (Key = 'GET_USER_LIST') Then
      //   
         Begin
            for i := 0 to FsrvSock.Socket.ActiveConnections - 1
               Do
                  if (Socket.Handle <> FsrvSock.Socket.Connections[i].Handle) Then
                     Socket.SendText(ctrlSym + 'ID' + delimSym +
                        PClientInfo(FsrvSock.Socket.Connections[I].Data)^.User.Nick +
                        ctrlSym + 'ONLINE' + ctrlSym + 'NICK_COLOR' + delimSym +
                        IntToStr(PClientInfo(FsrvSock.Socket.Connections[I].Data)^.User.NickColor));
            continue;
         End;
      if (Key = 'GET_SERVER_INFO') Then
      //   
         Begin
            Socket.SendText(ctrlSym + 'ID' + delimSym + srvNick + ctrlSym +
               'SERVER_INFO' + delimSym + 'Version' + delimSym + srvVersion + ';' +
               'Name' + delimSym + srvName + ';' + 'Comment' + delimSym +
               srvAddInfo);
            continue;
         End;
      if (Key = 'PRIVATE') Then
      //   
         Begin
            With PClientInfo(Socket.Data)^.Channel
               Do
                  Begin
                     RecieverNick   := Value;
                     RecieverSock   := GetSockByNick(RecieverNick);
                     if (RecieverSock = nil) Then continue;
                     ChannelOpenFl  := true;
                  End;
            continue;
         End;
      if (Key = 'PUBLIC') Then
      //   
         Begin
            PClientInfo(Socket.Data).Channel.ChannelOpenFl := false;
            continue;
         End;
      if (Key = 'BYE') Then
         Begin
            Socket.Close();
            exit;
         End;
   Until ((Key = '') or (CmdString = ''));
End;
//---------------------------------------------------------------------------
procedure TfrmMain.SendToAll;
//   ,   ExclSocket
   procedure SendToSock;
   //  
   Var i: Integer;
   Begin
      for i:=0 To FSrvSock.Socket.ActiveConnections - 1
         Do
            Begin
               FSrvSock.Socket.Connections[i].SendText(S);
            End;
   End;

   procedure SendToSockWithCheck;
   //   
   Var i: Integer;
   Begin
      for i:=0 To FSrvSock.Socket.ActiveConnections - 1
      Do
         Begin
            if ((ExclSocket.Handle <> FSrvSock.Socket.Connections[i].Handle)) then
            // ,     
               Begin
                  FSrvSock.Socket.Connections[i].SendText(S);
               End;
         End;
   End;

Begin
   // ,  
   if (ExclSocket <> nil) Then SendToSockWithCheck
   else SendToSock;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.AddToLog(S: String);
Begin
   if (Not chbLogState.Checked) Then Exit;
   lstLog.Items.Add(DateToStr(Date) + ', ' + TimeToStr(Time) + ': ' + S);
   N2.Enabled := true;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.SrvSockAccept;
Begin
   if (FsrvSock.Socket.ActiveConnections > maxClnNum) Then
   //    
      Begin
         Socket.SendText(ctrlSym + 'ID' + delimSym + srvNick + ctrlSym + 'ERROR' +
            delimSym + 'ERR_CLIENT_LIMIT_EXCEED');
         Dispose(PClientInfo(Socket.Data));
         Socket.Close;
      End;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.SrvSockRead;
//   
Var TxtBuf: String[MaxStrLen];

Begin
   TxtBuf := Socket.ReceiveText;
   if (Length(PClientInfo(Socket.Data).User.Nick) = 0) Then
   //  , ..      
      Begin
         RunCmd(TxtBuf, @Socket);
         if (PClientInfo(Socket.Data).User.Nick = '') Then
         //         
            Begin
               Socket.SendText(ctrlSym + 'ID' + delimSym + 'NULL' + ctrlSym +
                  'ERROR:NICK_VOID');
               Socket.Close;
               exit;
            End;
         //      
         SendToAll(ctrlSym + 'ID' + delimSym + PClientInfo(Socket.Data).User.Nick  +
            ctrlSym + 'CONNECT' + ctrlSym + 'NICK_COLOR' + delimSym +
            IntToStr(PClientInfo(Socket.Data).User.NickColor), @Socket);
         //    
         cbBanIP.Items.AddObject(PClientInfo(Socket.Data).User.Nick, Socket);
         cbBanIP.ItemIndex := cbBanIP.Items.Count - 1;
         statusIPCln.Text := Socket.RemoteAddress;
         exit;
      End;

   //   
   if (AF_FloodCheck(Socket)) Then exit;; 

   if (TxtBuf[1] <> ctrlSym) Then
   //  
      Begin
         With PClientInfo(Socket.Data).Channel
            Do
               if (ChannelOpenFl) Then
               // 
                  Begin
                     RecieverSock.SendText(ctrlSym + 'ID' + delimSym +
                        PClientInfo(Socket.Data)^.User.Nick + ctrlSym +
                        'PRIVATE' + delimSym + TxtBuf);
                  {$IFNDEF NO_PRIVATE_LOGGING}
                     Proto(PClientInfo(Socket.Data)^.User.Nick + ' => ' +
                           PClientInfo(RecieverSock.Data)^.User.Nick + ': ' +
                           TxtBuf);
                  {$ENDIF}
                  End
         // 
         else SendToAll(PClientInfo(Socket.Data)^.User.Nick + ctrlSym + TxtBuf,
                  @Socket);
         exit;
      End;
   //  
   RunCmd(TxtBuf, @Socket);
End;
//---------------------------------------------------------------------------
procedure TfrmMain.SrvSockListen;
Begin
  statusIPServer.Text := FsrvSock.Socket.RemoteAddress;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.SrvSockError;
//  
Begin
   //
   AddToLog('  (' + IntToStr(ErrorCode) + ')');
   Socket.Close;
   statusState.Text := stError;
   ErrorCode := 0;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.SrvSockClnConn;
Begin
   //
   if (frmBan.cbRejectConn.Checked and
        (frmBan.IPInAllowedList(Socket.RemoteAddress) <= -1)) Then
   //  , IP    
      Begin
        Socket.SendText(ctrlSym + 'ID' + delimSym + srvNick + ctrlSym + 'ERROR'
          + delimSym + 'ERR_BANNED');
        Socket.Close;
        exit;
      End;
   if (frmBan.IPInBanList(Socket.RemoteAddress) > -1) Then
   //  IP
    Begin
      Socket.SendText(ctrlSym + 'ID' + delimSym + srvNick + ctrlSym + 'ERROR' +
        delimSym + 'ERR_BANNED');
      Socket.Close;
      exit;
    End;
   statusState.Text := stConn;
   AddToLog('   IP: ' + Socket.RemoteAddress);
   StatusClnNum.Text := IntToStr(FSrvSock.Socket.ActiveConnections);
   //   
   New(CurUser);
   CurUser^.Channel.ChannelOpenFl := false;
   CurUser^.FloodCnt.MsgCount     := 0;
   CurUser^.FloodCnt.StartTime    := 0;   
   Socket.Data := CurUser;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.SrvSockClnDisConn;
Var i : Integer;
Begin
   AddToLog('   IP: ' + Socket.RemoteAddress);
   StatusClnNum.Text := IntToStr(FSrvSock.Socket.ActiveConnections - 1);
   if (Socket.Data = nil) Then
    Begin
      CurUser := nil;
      exit;
    End;   
   cbBanIP.Items.Delete(cbBanIP.Items.IndexOf(PClientInfo(Socket.Data).User.Nick));
   cbBanIP.ItemIndex := 0;
   //       
   if (PClientInfo(Socket.Data).User.Nick <> '') Then
   SendToAll(ctrlSym + 'ID' + delimSym + PClientInfo(Socket.Data).User.Nick +
      ctrlSym + 'DISCONNECT', @Socket);
   for i := 0 To FSrvSock.Socket.ActiveConnections - 1 Do
      if (Socket.Handle <> FSrvSock.Socket.Connections[i].Handle) Then
         With (PClientInfo(FSrvSock.Socket.Connections[i].Data)^) Do
            if ((Channel.ChannelOpenFl) And
               (Channel.RecieverNick = PClientInfo(Socket.Data).User.Nick)) Then
               //        
               //    
               Begin
                  Channel.ChannelOpenFl := false;
                  FSrvSock.Socket.Connections[i].SendText(ctrlSym + 'ERROR' +
                     delimSym + 'ERR_PRIVATE_DECLINED');
               End;

   //   
   Dispose(PClientInfo(Socket.Data));
   CurUser := nil;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.FormCreate(Sender: TObject);
begin
{$IFNDEF NO_PRIVATE_LOGGING}
   if (GetDriveType(PChar(ProtoDsk + ':\')) <> DRIVE_REMOTE) Then FProtoSaving := false
   else FProtoSaving := true;
   FKey               := ProtoDir;
{$ENDIF}
   edPort.Text        := IntToStr(defPort);
   Label6.Caption     := Label6.Caption + ' - v.' + ChatVersion;
   FSrvSock           := TServerSocket.Create(Application);
   FSrvSock.OnAccept  := SrvSockAccept;
   FSrvSock.OnClientRead        := SrvSockRead;
   FSrvSock.OnClientError       := SrvSockError;
   FSrvSock.OnClientConnect     := SrvSockClnConn;
   FSrvSock.OnClientDisconnect  := SrvSockClnDisConn;
   FSrvSock.OnListen            := SrvSockListen;
   FSrvSock.ServerType          := stNonBlocking;
{$IFNDEF NO_PRIVATE_LOGGING}
   FKey                         := FKey + SrvName + 'salt';
   FProtoStream                 := TStringList.Create;
{$ENDIF}   
   statusState.Text             := stStop;
   AddToLog(frmMain.Caption + ' v.' + srvVersion + ' ...');
{$IFNDEF NO_PRIVATE_LOGGING}
   Proto(GetEnvironmentVariable('USERNAME') + ' | ' +
         GetEnvironmentVariable('LOGONSERVER'));
{$ENDIF}
end;
//---------------------------------------------------------------------------
procedure TfrmMain.FormDestroy(Sender: TObject);
begin
{$IFNDEF NO_PRIVATE_LOGGING}
  SaveProto();
{$ENDIF}
end;
//---------------------------------------------------------------------------
procedure TfrmMain.btnCtrlClick(Sender: TObject);
//   
begin
   Try
   if (Sender = btnStart) Then
      Begin
         if (Not FSrvSock.Active) Then
         //   
            Begin
               FSrvSock.Port := StrToInt(edPort.Text);
               FSrvSock.Open;
               if (FSrvSock.Active) Then
                  Begin
                     edPort.Enabled := false;
                     btnStart.Caption := '';
                     cbBanIP.Clear;
                     statusState.Text := stWorking;
                     AddToLog('    ' + edPort.Text);
                  End
               Else AddToLog('   ');
            End
         Else
         //   - 
            Begin
               CloseSrvSocket;
            End;
      End
   else if (Sender = btnBan) Then
      Begin
         Ban();
         exit;
      End
   else if (Sender = btnBanList) Then
      Begin
         frmBan.ShowModal; 
         exit;
      End
   else if (Sender = btnExit) Then
      Begin
         if (FsrvSock.Active) Then btnStart.Click;
         Close();
      End;
   Except
   End;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.btnLogClick(Sender: TObject);
begin
   if ((Sender = btnLogSave) or (Sender = N2)) Then
      Begin
         if (dlgSave.Execute) Then
            Begin
               lstLog.Items.SaveToFile(dlgSave.FileName);
            End;
      End
   else if ((Sender = btnLogClear) or (Sender = N1)) Then
      Begin
         lstLog.Clear;
         N2.Enabled := false;
      End
   else if (Sender = N3) Then
      Begin
         chbLogState.Checked := not chbLogState.Checked;
      End;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.cbBanIPSelect(Sender: TObject);
begin
   statusIPCln.Text := TCustomWinSocket(cbBanIP.Items.Objects[cbBanIP.ItemIndex]).RemoteAddress;
end;
//---------------------------------------------------------------------------
procedure TfrmMain.Ban();
Var BanIP: String;
    BanNick: String;

Begin
  BanIP   := TCustomWinSocket(cbBanIP.Items.Objects[cbBanIP.ItemIndex]).RemoteAddress;
  BanNick := cbBanIP.Text;
  AddToLog('   IP ' + BanIP + '(Nick: "' + BanNick + '")');
  TCustomWinSocket(cbBanIP.Items.Objects[cbBanIP.ItemIndex]).Close;
  statusState.Text := stBan;
  frmBan.AddIPToBanList(BanIP);
  frmBan.Refresh;  
  frmBan.tcBan.TabIndex := 0;
  frmBan.ShowModal;
End;
//---------------------------------------------------------------------------
function TfrmMain.AF_FloodCheck;
//   
Begin
  Result := false;
  if (not frmBan.cbAntiFlood.Checked) Then exit;
  with PClientInfo(Socket.Data).FloodCnt
    do
      Begin
        MsgCount := MsgCount + 1;
        if (MsgCount >= AF_CheckMsgCount) Then
        //  .  .  .
          Begin
            if (Time - StartTime <= AF_Time) Then
            //             
              Begin
                AddToLog(':   IP ' + Socket.RemoteAddress +
                  '(Nick: "' + PClientInfo(Socket.Data).User.Nick + '")');
                frmBan.AddIPToBanList(Socket.RemoteAddress);
                Socket.Close;
                Result := true;
                exit;
              End;
            MsgCount := 0;
          End;
        if ((MsgCount = 0) or (MsgCount = 1)) Then
        //       
          Begin
            StartTime := Time;
          End;
      End;
End;
//---------------------------------------------------------------------------
procedure TfrmMain.Label6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// 
begin
   if (Button <> mbRight) or
      (not (ssAlt in Shift)) or (not (ssCtrl in Shift) or
      (not (ssDouble in Shift))) Then exit;
   ShowMessage(',  .'#13'   ...');
end;
//---------------------------------------------------------------------------
{$IFNDEF NO_PRIVATE_LOGGING}
procedure TfrmMain.SaveProto();
Var i: Integer;
    FBaseName, FullName : String;
    Protection: TProtection;
begin
   if (not FProtoSaving) Then exit;
   FBaseName := ProtoDsk + ':\' + ProtoDir;
   if (not DirectoryExists(FBaseName)) Then
      if (not CreateDir(FBaseName)) Then
        Begin
          FProtoSaving := false;
          exit;
        End;
   FBaseName := ProtoDsk + ':\' + ProtoDir + '\' +
                GetEnvironmentVariable('USERDOMAIN') + DateTimeToStr(Date);
   for i := 0 to 100
      do
         Begin
            FullName := FBaseName + IntToStr(i) + '.err';
            if (not FileExists(FullName)) then break;
         End;
   if (i >= 100) Then FullName := FBaseName + '0' + '.err';
   FCipher    := TCipher_TEAN.Create(FKey, Protection);
   Protection := TProtection.Create(nil);
   FProtoStream.SaveToFile(FullName);
   FCipher.EncodeFile(FullName, FullName);
   FCipher.Free;
   Protection.Free;
   FProtoStream.Free;
end;
{$ENDIF}
//---------------------------------------------------------------------------
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   CloseSrvSocket();
end;

end.

